=== modified file 'lib/lp/bugs/browser/bugtask.py'
--- lib/lp/bugs/browser/bugtask.py	2011-12-15 14:27:15 +0000
+++ lib/lp/bugs/browser/bugtask.py	2011-12-15 18:55:46 +0000
@@ -2226,6 +2226,14 @@
         assignee = None
         if self.assignee is not None:
             assignee = self.assignee.displayname
+
+        base_tag_url = "%s/?field.tag=" % canonical_url(
+            self.bugtask.target,
+            view_name="+bugs")
+
+        def build_tag_url(tag):
+            """Generate a url for the tag based on the current request ctx."""
+
         return {
             'age': age,
             'assignee': assignee,
@@ -2242,7 +2250,8 @@
             'reporter': self.bug.owner.displayname,
             'status': self.status.title,
             'status_class': 'status' + self.status.name,
-            'tags': ' '.join(self.bug.tags),
+            'tags': [{'url': base_tag_url + tag, 'tag': tag}
+                for tag in self.bug.tags],
             'title': self.bug.title,
             }
 

=== modified file 'lib/lp/bugs/browser/tests/test_bugtask.py'
--- lib/lp/bugs/browser/tests/test_bugtask.py	2011-12-15 14:27:15 +0000
+++ lib/lp/bugs/browser/tests/test_bugtask.py	2011-12-15 18:55:46 +0000
@@ -2148,7 +2148,8 @@
             'milestone_name': 'milestone_name1',
             'status': 'status1',
             'reporter': 'reporter1',
-            'tags': 'tags1',
+            'tags': [{'tag': 'tags1'}],
+            'tag_urls': [{'url': '', 'tag': 'tags1'}],
             'title': 'title1',
         }
         item.update(navigator.field_visibility)
@@ -2343,7 +2344,10 @@
         owner, item = make_bug_task_listing_item(self.factory)
         with person_logged_in(owner):
             item.bug.tags = ['tag1', 'tag2']
-            self.assertEqual('tag1 tag2', item.model['tags'])
+            self.assertEqual(2, len(item.model['tags']))
+            self.assertTrue('tag' in item.model['tags'][0].keys())
+            self.assertTrue('url' in item.model['tags'][0].keys())
+            self.assertTrue('field.tag' in item.model['tags'][0]['url'])
 
     def test_model_reporter(self):
         """Model contains bug reporter."""

=== modified file 'lib/lp/bugs/templates/buglisting.mustache'
--- lib/lp/bugs/templates/buglisting.mustache	2011-12-14 19:23:02 +0000
+++ lib/lp/bugs/templates/buglisting.mustache	2011-12-15 18:55:46 +0000
@@ -61,7 +61,9 @@
             {{/show_datecreated}}
             {{#show_tag}}
                 <span class="field">Tags:
-                  {{#tags}}{{tags}}{{/tags}}
+                  {{#tags}}
+                    <a href="{{url}}" class="tag">{{tag}}</a>
+                  {{/tags}}
                   {{^tags}}None{{/tags}}
                 </span>
             {{/show_tag}}

